///////////////////////////////////////////////////////////////////////////////
//
// Wall Paper Changer for GNOME
// Copyright (C) 2000-2001  Kenichi Shibata <ken_s@cat.zero.ad.jp>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// Please read the file "COPYING" for more information.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
///////////////////////////////////////////////////////////////////////////////
//
// ken_s@cat.zero.ad.jp
// http://www3.might.co.jp/~sibata/top/
//
///////////////////////////////////////////////////////////////////////////////

// COMMON /////////////////////////////////////////////////////////////////////

//--- Proto type ------------------------------------------
void initial_wpac_timer(void);
void timeout_wallpaper_change(gpointer data);
void main_dialog_init(void);
gboolean on_main_dialog_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data);
gboolean on_main_dialog_destroy_event (GtkWidget *widget, GdkEvent *event,gpointer user_data);
void on_image_file_clist_select_row (GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data);
void on_image_file_clist_unselect_row (GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data);
void on_mode_sequential_radiobutton_toggled (GtkToggleButton *togglebutton, gpointer user_data);
void on_mode_random_radiobutton_toggled (GtkToggleButton *togglebutton, gpointer user_data);
void on_timeliness_manual_radio_toggled (GtkToggleButton *togglebutton, gpointer user_data);
void on_timeliness_auto_radio_toggled(GtkToggleButton *togglebutton, gpointer user_data);
void on_minute_entry_insert_text (GtkEditable *editable, gchar *new_text, gint new_text_length, gint *position, gpointer user_data);
void on_minute_entry_changed (GtkEditable *editable, gpointer user_data);
void on_add_button_clicked (GtkButton *button, gpointer user_data);
void on_del_button_clicked (GtkButton *button, gpointer user_data);
void on_all_select_button_clicked (GtkButton *button, gpointer user_data);
void on_all_unselect_button_clicked (GtkButton *button, gpointer user_data);
void on_layout_center_radiobutton_toggled (GtkToggleButton *togglebutton, gpointer user_data);
void on_layout_full_radiobutton_toggled (GtkToggleButton *togglebutton, gpointer user_data);
void on_layout_tile_radiobutton_toggled (GtkToggleButton *togglebutton, gpointer user_data);
void on_dither_checkbutton_toggled (GtkToggleButton *togglebutton, gpointer user_data);
void on_gray_checkbutton_toggled (GtkToggleButton *togglebutton, gpointer user_data);
void on_rotate_hscale_value_changed (GtkWidget *widget, gpointer user_data);
void on_gamma_hscale_value_changed (GtkWidget *widget, gpointer user_data);
void on_brighten_hscale_value_changed (GtkWidget *widget, gpointer user_data);
void on_xy_checkbutton_toggled (GtkToggleButton *togglebutton, gpointer user_data);
void on_xzoom_hscale_value_changed (GtkWidget *widget, gpointer user_data);
void on_yzoom_hscale_value_changed (GtkWidget *widget, gpointer user_data);
void on_bg_colorselection_color_changed (GtkColorSelection *colorselection, gpointer user_data);
void on_option_entry_changed (GtkEditable *editable, gpointer user_data);
void on_test_button_clicked (GtkButton *button, gpointer user_data);
void on_wpac_notebook_switch_page (GtkNotebook *notebook, GtkNotebookPage *page, gint page_num, gpointer user_data);
void on_save_button_clicked (GtkButton *button, gpointer user_data);
void on_ok_button_clicked (GtkButton *button, gpointer user_data);
void on_cancel_button_clicked (GtkButton *button, gpointer user_data);
void on_about_button_clicked (GtkButton *button, gpointer user_data);
void on_exit_button_clicked (GtkButton *button, gpointer user_data);
gboolean on_fileselection_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data);
gboolean on_fileselection_destroy_event (GtkWidget *widget, GdkEvent *event, gpointer user_data);
void on_fileselect_ok_button_clicked (GtkButton *button, gpointer user_data);
void on_fileselect_cancel_button_clicked (GtkButton *button, gpointer user_data);
gboolean on_about_dialog_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data);
gboolean on_about_dialog_destroy (GtkWidget *widget, GdkEvent *event, gpointer user_data);
void on_about_ok_button_clicked (GtkButton *button, gpointer user_data);
void on_applet_property_button(AppletWidget *applet, gpointer data);
void on_save_yes_button_clicked (GtkButton *button, gpointer user_data);
void on_save_no_button_clicked (GtkButton *button, gpointer user_data);


// LOCAL //////////////////////////////////////////////////////////////////////
#ifdef __CALLBACKS_H
//--- Proto type ------------------------------------------
static gboolean find_imagefile_clist(gchar *find_filename);
static void change_sensitive_deleteButton(GtkCList *image_file_list);
static void common_page_data_save(void);
static gboolean common_page_data_comp(void);
static void change_sensitive_SelectButton(GtkCList *clist);
static void individual_page_data_load(void);
static void individual_page_data_save(gint row);
static gboolean individual_page_data_comp(void);
static void individual_page_widget_enable(gboolean enable);
static guint get_value_individual_page_scale(gchar *name);
static void set_text_individual_page_entry(gchar *name, gchar *str);
static void check_notebook_data(void);


// GLOBAL /////////////////////////////////////////////////////////////////////
#else   // __CALLBACKS_H

#endif  // __CALLBACKS_H

